//#include <windows.h>
//#include <time.h>

#define bla_KEYBUFSIZ		1024	// 2ׂ̂ɂȂ΂Ȃ.

#if (defined(KGDI32))
	typedef HWND WID_t;
#elif (defined(KSDL1))
	typedef struct bla_Window_ *WID_t;
#elif (defined(KSDL2))
	typedef SDL_Window *WID_t;
#elif (defined(KCONSONLY))
	typedef void *WID_t;	// dummy
#endif

typedef struct bla_Window_ {
	char title[64];
	int xsiz, ysiz, *buf, table_idx, keybuf[bla_KEYBUFSIZ], kbw, kbr;
	clock_t lastFlush;
	signed char phase, mode, autoClose;
	WID_t hWnd;
	#if (defined(KGDI32))
		HINSTANCE hInst;
		BITMAPINFO bmi;
	#elif (defined(KSDL1))
		SDL_Thread *child;
		SDL_Surface *surface;
	#elif (defined(KSDL2))
		SDL_Thread *child;
		SDL_Renderer *renderer;
	#endif
} bla_Window;

// level0
int bla_main(int argc, const char **argv);
STATIC void bla_exit(int c);
STATIC void bla_wait(int msec);
STATIC bla_Window *bla_openWin(int xsiz, int ysiz, const char *title, int autoClose);
STATIC void bla_closeWin(bla_Window *w);
STATIC void bla_flushAll(bla_Window *w);

#define bla_MODE_SET		0
#define bla_MODE_OR			1
#define bla_MODE_AND		2
#define bla_MODE_XOR		3

#define bla_KEY_ENTER		10
#define bla_KEY_ESC			27
#define bla_KEY_BACKSPACE	8
#define bla_KEY_TAB			9
#define bla_KEY_PAGEUP		0x1020
#define bla_KEY_PAGEDWN		0x1021
#define	bla_KEY_END			0x1022
#define	bla_KEY_HOME		0x1023
#define bla_KEY_LEFT		0x1024
#define bla_KEY_RIGHT		0x1025
#define bla_KEY_UP			0x1026
#define bla_KEY_DOWN		0x1027
#define bla_KEY_INS			0x1028
#define bla_KEY_DEL			0x1029

#define bla_KEY_LOCKS		0x00f00000

// level1
STATIC void bla_end();
STATIC void bla_leapFlushAll(bla_Window *w, unsigned int t);
STATIC int bla_inkey(bla_Window *w);
STATIC int bla_inkey0(bla_Window *w);	// peek邾.
inline static int bla_rgb(int r, int g, int b) { return r << 16 | g << 8 | b; }
inline static void bla_setPix(bla_Window *w, int x, int y, int c) { w->buf[y * w->xsiz + x] = c; }
inline static int bla_getPix(bla_Window *w, int x, int y) { return w->buf[y * w->xsiz + x]; }
STATIC void bla_setPixEx(bla_Window *w, int x, int y, int c);
STATIC void bla_fillRect(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_fillRectEx(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_drawRect(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_drawRectEx(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_drawStr(bla_Window *w, int x, int y, int c, int b, const char *s);
STATIC void bla_drawStrEx(bla_Window *w, int x, int y, int c, int b, const char *s);
STATIC void bla_drawLine(bla_Window *w, int x0, int y0, int x1, int y1, int c);
STATIC void bla_drawLineEx(bla_Window *w, int x0, int y0, int x1, int y1, int c);
STATIC void bla_fillOval(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_fillOvalEx(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_drawOvalEx(bla_Window *w, int sx, int sy, int x0, int y0, int c);
inline static void bla_setMode(bla_Window *w, int m) { w->mode = m; }
STATIC void bla_fillEx(bla_Window *w, int x, int y, int c);
STATIC void bla_waitEx(int msec);
